<?php

define('DOKU_AUTH', dirname(__FILE__));
require_once(DOKU_AUTH.'/basic.class.php');

class auth_aai extends auth_basic {

		var $cando = array (
			'addUser'     => false, // can Users be created?
			'delUser'     => false, // can Users be deleted?
			'modLogin'    => false, // can login names be changed?
			'modPass'     => false, // can passwords be changed?
			'modName'     => false, // can real names be changed?
			'modMail'     => false, // can emails be changed?
			'modGroups'   => false, // can groups be changed?
			'getUsers'    => false, // can a (filtered) list of users be retrieved?
			'getUserCount'=> false, // can the number of users be retrieved?
			'getGroups'   => false, // can a list of available groups be retrieved?
			'external'    => false, // does the module do external auth checking?
			'logoff'      => false, // has the module some special logoff method?
		);
		
		var $auth;

						

    function auth_aai($lib_path = ''){
			$lib_path = DOKU_AUTH . '/auth_plugin/';
			require_once($lib_path . 'auth.php');
			$this->auth = new Auth($lib_path);		
    }

    function checkPass($user,$pass){
			global  $fws_domains;
			if (isset($fws_domains) && is_array($fws_domains) && count($fws_domains) > 0) {
				// ovdje ulazi samo ako postoji white lista
				$domain = $this->_getDomain(strtolower($user));
				if (!in_array($domain,$fws_domains)) {
					// domena nije na white listi 
					return false;
				}		
			}			
			$result = $this->auth->authenticate($user,$pass);
			if (!$result) {
				$message = $this->auth->get_message();	
				// echo 	"<hr>$message<hr>";				
			}
			return $result;
    }

    function getUserData($user) {
			global $conf;
			if (isset($this->auth) && $this->auth->is_authenticated()) {
				$u = $this->auth->user;
				$u['name'] = $u['givenName'].' '.$u['sn'];
				$u['mail'] = $u['mail'];
				$u['mail'] = 'user';
				$u['grps'] = array('user'); // ako spada jos u neke grupe tu bi to trebalo dodati								
				return $u;
			}
			return false;
    }
		
	
		function _getDomain($username){
			$p = strpos($username,'@');	
			if ($p === false) {
				$domain = 'nodomain';
			} else {
				$domain = substr($username,$p+1);
				if (strlen(trim($domain)) == 0) {
					$domain = 'nodomain';
				}
			}
			return $domain;
		}
}
?>
